leetcode 494 Target sum

来源:互联网 发布:淘宝ppc计算公式 编辑:程序博客网 时间:2024/06/05 16:36

题目描述:

You are given a list of non-negative integers, a1, a2, …, an, and a target, S. Now you have 2 symbols + and -. For each integer, you should choose one from + and - as its new symbol.

Find out how many ways to assign symbols to make sum of integers equal to target S.

Example 1:
Input: nums is [1, 1, 1, 1, 1], S is 3.
Output: 5
Explanation:

-1+1+1+1+1 = 3
+1-1+1+1+1 = 3
+1+1-1+1+1 = 3
+1+1+1-1+1 = 3
+1+1+1+1-1 = 3

There are 5 ways to assign symbols to make the sum of nums be target 3.
Note:
The length of the given array is positive and will not exceed 20.
The sum of elements in the given array will not exceed 1000.
Your output answer is guaranteed to be fitted in a 32-bit integer.

解题思路

这道题第一反应是用动态规划来解,但似乎简单地找最优子结构不奏效,之后的想法是回溯,但复杂度似乎过高了,看了AC解后发现解确实很巧妙,在使用dp前先对原问题进行了化简,这是很重要的一步,观察题目,数组元素的一部分和与另一部分做差得到target,很容易可以有下面的公式:

sum(p) - sum(q) = target (1) p和q分别代表数组元素的子集
而我们有:
sum(p)+sum(q) = sum(array) (2)
(1)+(2)则有 2*sum(p) = target+sum(array);
因此问题就简化成了在数组中找一堆数使得他们的和满足上述关系,这比原问题要简单得多,也可以很容易使用dp来解,当前值的可能情况个数 = 当前值个数+dp[当前值-数组元素 ]
尝试写出问题解:

    int target(vector<int>&nums,int S) {        auto sumArray = accumulate(nums.begin(),nums.end(),0);        //必须是2的倍数        if(sum<S||(sum+S)&1)            return 0;        auto realTarget = (sumArray+S)/2;        vector<int>dp(realTarget+1,0);        dp[0]=1;        for(auto&val:nums) {            for(int i = realTarget;i>=0;i--) {                dp[i]+=dp[i-val];            }        }    }
0 0
原创粉丝点击